// Pro krokový motor 28BYJ-48 s řadičem ULN2003
// ZKUŠEBNÍ VERZE 1


// čísla pinů pro digitální výstupy
const int in1 =  8;
const int in2 =  9;
const int in3 = 10;
const int in4 = 11;

const int buttonpin = 2; //pin tlačítka1 směr hodin
const int buttonpin1 = 3; //pin tlačítka2 směr proti hodin
const int buttonpin2 = 4; //pin tlačítka3 najetí na výchozí polohu
const int buttonpin3 = 5; //pin mikrospínače najetí na výchozí polohu vpravo
const int buttonpin4 = 6; //pin mikrospínače najetí na výchozí polohu vlevo
 
int rychlost = 1; // proměnná pro nastavení rychlosti,se zvětšujícím se číslem se rychlost zmenšuje

int uhel = 10; // proměnná úhel otočení na jeden cyklus
int otocka = 0; // proměnná počet cyklů ( délka přejezdu posuvny )

void setup() {

pinMode(buttonpin, INPUT);  // pin tlačítka1 směr hodin
pinMode(buttonpin1, INPUT); // pin tlačítka2 směr proti hodin
pinMode(buttonpin2, INPUT); // pin tlačítka3 najetí na výchozí polohu
pinMode(buttonpin3, INPUT); // pin mikrospínače najetí na výchozí polohu vpravo
pinMode(buttonpin4, INPUT); // pin mikrospínače najetí na výchozí polohu vlevo
  
  // inicializace digitálních výstupů
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
}


void loop()  {

int button_state = digitalRead(buttonpin);
int button_state4 = digitalRead(buttonpin4);

if (button_state == LOW){  // motor stojí když je tlačítko1 rozpojeno
  int uhel = 0;
}
else if (button_state4 == LOW) // když je levý mikrospínač rozpojen a tlačítko1 spojeno točí se motor po směru hodin
otocka = 68; // počet cyklů
while(otocka>0)
{
rotaceProtiSmeru(); // opačně pojmenovaná funkce
otocka--;

for(int i=0;i<(uhel*64/45);i++) // motor udělá pohyb směru hodin o nastavený úhel
rotaceProtiSmeru(); // opačně pojmenovaná funkce
 
}
 
 {
int button1_state = digitalRead(buttonpin1);
int button3_state = digitalRead(buttonpin3);

if ((button1_state == HIGH)&&(button3_state == LOW)) // když je tlačítko2 spojeno a pravý mikrospínač rozpojen točí se motor protisměru hodin

otocka = 68; // počet cyklů
while(otocka>0)
{
rotacePoSmeru(); // opačně pojmenovaná funkce
otocka--;
  
for(int i=0;i<(uhel*64/45);i++) // motor udělá pohyb proti směru hodin o nastavený úhel
  rotacePoSmeru(); // opačně pojmenovaná funkce
}

{
int button2_state = digitalRead(buttonpin2);
int button3_state = digitalRead(buttonpin3);

if ((button2_state == HIGH)&&(button3_state == LOW)) // motor se točí protisměru hodin dokud je spojeno tlačítko3 a rozpojen pravý mikrospínač
  rotacePoSmeru();  // opačně pojmenovaná funkce
 
}}}

// zde následují funkce pro volání jednotlivých
// kroků pro otočení po či proti směru hodinových
// ručiček
void rotacePoSmeru() {     // opačně pojmenovaná funkce
  krok1();
  krok2();
  krok3();
  krok4();
  krok5();
  krok6();
  krok7();
  krok8();
}
void rotaceProtiSmeru() {    // opačně pojmenovaná funkce
  krok8();
  krok7();
  krok6();
  krok5();
  krok4();
  krok3();
  krok2();
  krok1();
}
// každý krok obsahuje výrobcem dané pořadí
// pro správné spínání motoru a následnou
// pauzu, kterou určujeme rychlost otáčení
void krok1(){
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);
  delay(rychlost);
}
void krok2(){
  digitalWrite(in1, HIGH);
  digitalWrite(in2, HIGH);
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);
  delay(rychlost);
}
void krok3(){
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);
  delay(rychlost);
}
void krok4(){
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  delay(rychlost);
}
void krok5(){
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  delay(rychlost);
}
void krok6(){
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, HIGH);
  delay(rychlost);
}
void krok7(){
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, HIGH);
  delay(rychlost);
}
void krok8(){
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, HIGH);
  delay(rychlost);
}




